| Copyright (C) 2003 Daniel De Graaf

   .set ver_89, 1         |Run on the TI-89 [zero or comment for TI-92+]
   .set nostub_comment, 1 |Include the new nostub comment header

.ifndef ver_89
  .set ver_89, 0
.endif
.ifndef nostub_comment
  .set nostub_comment, 0
.endif

PRGM_START:
|all the global variables
	.global make
	.global solve
	.global play
	.global disp
	.global DispMenu
	.global DrawStrR
	.global rowread
	.global TXT_Maze
	.global P_TXT_Maze
	.global setting
	.global set_W
	.global set_H
	.global SetInts
	.global RestoreInts
|lowercase k is key bit number
|K = 2^k
| 'rowread(key_1)&key_2' gives value

.if ver_89
	.set enter_1, 2
	.set enter_2, 1
	.set esc_1, 64
	.set esc_2, 1
	.set apps_1, 32
	.set apps_2, 1
	.set num8_1, 16
	.set num8_2, 8
	.set k_R, 3
	.set k_D, 2
	.set k_L, 1
	.set k_diamond, 6
	.set K_diamond, 64
	.set k_second, 4
	.set K_second, 16
	.set K_shift, 32
	.set DrawStrR_Xval, 7
	.set TitleRow, 5
	.set Menu_ItemHeight, 10
	.set YourX, 8
	.set YourY, 6
	.set YouWinX, 40
	.set YouWinY, 40
.else
	.set enter_1, 512
	.set enter_2, 2
	.set esc_1, 256
	.set esc_2, 64
	.set apps_1, 128
	.set apps_2, 64
	.set num8_1, 8
	.set num8_2, 32
	.set k_R, 6
	.set k_D, 7
	.set k_L, 4
	.set k_U, 5
	.set k_diamond, 1
	.set K_diamond, 2
	.set k_second, 0
	.set K_second, 1
	.set K_shift, 4
	.set DrawStrR_Xval, 17
	.set TitleRow, 10
	.set Menu_ItemHeight, 13
	.set YourX, 10
	.set YourY, 8
	.set YouWinX, 70
	.set YouWinY, 60
.endif

|Iterations when making the maze
	.set Iterations, 50
|Number of times 'idle()' is called
	.set intersection_delay,20 |just reached an intersection
	.set play_delay,5   |just pressed a key, with no intersection
	.set nokey_delay,10 |no key, wait longer


.if nostub_comment
|Nostub comment
	move.l (%a7),(%a7)
	bra.w main
	.word 0x2e76, 0x5c7b, 0x4e74, 0x4e72, 0x4afc, 0
	.long 0x01000000
	.word 3
|Comment
	.word 0
	.word TXT_Comment-PRGM_START
|Name
	.word 1
	.word TXT_Maze-PRGM_START
|Version	
	.word 3
	.word Version-PRGM_START
 Version:
	.byte 1
	.byte 7
	.word 0
 TXT_Comment:
	.asciz "Make, solve, play mazes"
	.even
.endif

main:
	movem.l %d3-%d6/%a4-%a5, -(%sp) 
	 |d3-d5 are for File in-use
	 |d6 is FontGetSys
	 |a4 is memcpy address
	 |a5 is jump table
	move.l 0xC8,%a5
########################
# Start tests and save #
########################
	cmp.l #0x444,(%a5,-4) | Check for VarOptList ROMcall
	jbcc AMS_OK
	pea.l OldCalc
	move.l (%a5,0xE6*4),%a0 | ST_helpMsg 
	jsr (%a0)
	addq.l #4,%sp
	jbra Exit_to_TI
 AMS_OK:
| Set file in-use bit so that we have no problems
	lea.l (%pc),%a1
	move.l %a1,%d4     |current address 
	and.l #0x3FFFF,%d4 |Prevent problems HW2-TSR
	moveq #1,%d3       |set the bit
	jbsr in_use_bit    | Call function
| On failure, try using the return address of the program, to do the same for a possible launcher.
	tst.w %d0
	jbne FILE_OK
	move.l (%sp,6*4),%d4 | Get the return address
	cmp.l #0x1FFFFF,%d4  | Check if it is in RAM range
	jbhi FILE_OK         | If not, it's not the launcher
	and.l #0x3FFFF,%d4   | Prevent problems HW2-TSR
	jbsr in_use_bit      | Call function
 FILE_OK:

| redirect interrupt handlers so we have no misreads on keys
	move.l 0x64, int1 | AI1
	move.l 0x68, int2 | AI2
	move.l 0x70, int4 | AI4
	move.l 0x74, int5 | AI5
	jbsr SetInts

	lea (%sp,-0x1E00),%sp |two screens: TIOS and Maze
	pea 0xF00
	pea 0x4C00
	pea (%sp, 0xF08)
	move.l (%a5,0x26A*4),%a4 |memcpy
	jsr (%a4)

	move.l (%a5,0x18E*4),%a0 |FontGetSys
	jbsr (%a0)
	clr.w %d6
	move.b %d0,%d6

########################
#      Main Menu       #
########################
	lea (%sp,0xC),%a0
	pea (%a0)
	jbsr make
	jbsr Main
	move.w %d6,-(%sp)
	move.l (0x18F*4,%a5),%a0 |FontSetSys
	jbsr (%a0)

	pea 0xF00
	pea (%sp, 0xF16)
	pea 0x4C00
	jsr (%a4) |memcpy
	lea (%sp,0x1E1E),%sp

	jbsr in_use_bit |put in-use bit back
 Exit_to_TI:
	movem.l (%sp)+, %d3-%d6/%a4-%a5
|Both of these functions write to the IO ports, which is read-only memory.
|However, only the first RAM page is protected: this accesses the second
RestoreInts:
	move.l int1,0x40064
	move.l int2,0x40068
	move.l int4,0x40070
	move.l int5,0x40074
	rts
	.even
SetInts:
	move.l #rte_pointer,0x40064
	move.l #rte_pointer,0x40068
	move.l #rte_pointer,0x40070
	move.l #rte_pointer,0x40074
	rts
	.even
 rte_pointer: rte
 OldCalc: .asciz "Download AMS 2.00 or higher"
.even
setting:
 set_H: .byte 64
 set_W: .byte 80
 set_T: .byte 10
 set_P: .byte 30
 int1: .long 0
 int2: .long 0
 int4: .long 0
 int5: .long 0

	.even
| If set bit to value of %d3.w. If set, the previous value is in %d3.
| %d4 is an address in our program (or the launcher); %d5 is destroyed

in_use_bit:
| Call SymFindFirst with appropriate parameters to look for the handle.
	move.w #0x06,-(%sp) /* FO_RECURSE | FO_SKIP_TEMPS */
	clr.l -(%sp)
	move.l (%a5,0x6C*4),%a0 /* SymFindFirst */
	jbsr (%a0)
	addq.l #6,%sp
 __symbol_search_loop__:
| Store failure value in %d0
	clr.w %d0
| If the SYM_ENTRY pointer is 0, quit.
	move.l %a0,%d5
	jbeq __symbol_search_done__
| Dereference the handle from the SYM_ENTRY structure.
	move.w (%a0,12),-(%sp)
	move.l (%a5,0x96*4),%a0 /* HeapDeref */
	jbsr (%a0)
	addq.l #2,%sp
| If the address returned is higher than the address we are looking for, the
| symbol can't be the one.
| Actually, if it is equal, then something is seriously broken, but we don't
| check for that here.
	cmp.l %d4,%a0
	jbhi __skip_symbol__
| Add the size of the variable to %a0.
| Note that we would actually need to add 2 more bytes to skip the size
| field, but we make up for that by using a <= comparison.
	move.w (%a0),%d0
	add.l %d0,%a0
| If the end address is lower than the address we are looking for, the
| symbol can't be the one.
	cmp.l %d4,%a0
	jbls __skip_symbol__
| Store success result in %d0.
	moveq #1,%d0
| If %d3.w is 0, clear the in-use bit.
	move.l %d5,%a0
	tst.w %d3
	jbeq __clear_bit__
| Otherwise, store the previous value in %d3, set the bit, and quit.
	move.b (%a0,11),%d3
	and.w #0x10,%d3
	or.b #0x10,(%a0,11)
	rts
 __skip_symbol__:
| Call SymFindNext.
	move.l (%a5,0x6D*4),%a0 /* SymFindNext */
	jbsr (%a0)
| Go to beginning of loop.
	jra __symbol_search_loop__
 __clear_bit__:
	and.b #0xEF,(%a0,11)
 __symbol_search_done__:
	rts

	.even
make:
	movem.l %d3-%d7/%a2, -(%sp)
	clr.w %d6
	clr.w %d7
	move.b set_W,%d6
	move.b set_H,%d7

	move.b 0x600017,%d0
	move.l %d0, __randseed
	pea 0xF00.w
	pea 0x4C00.w
	move.l %a0, -(%sp) |LCD_save stack 
	move.l (%a5,0x19E*4),%a0 |clrscr
	jbsr (%a0)
	movea.l #0x4C00,%a0
	lea DrawScrnP, %a2
	clr.w %d3
 BorderXl:
	move.w %d3,%d0
	clr.w %d1
	jbsr (%a2)
	move.w %d3,%d0
	move.w %d7,%d1
	jbsr (%a2)
	addq.w #1,%d3
	cmp.w %d6, %d3
	jble BorderXl

	moveq.l #1,%d3
 BorderYl:
	move.w %d3,%d1
	clr.w %d0
	jbsr (%a2)
	move.w %d3,%d1
	move.w %d6,%d0
	jbsr (%a2)
	addq.w #1,%d3
	cmp.w %d7, %d3
	jblt BorderYl

	move.w %d6,%d0
	move.w %d7,%d1
	subq.w #1,%d1
	jbsr GetIncr__ | make a 'ClrP' 
	eor.b %d0,(%a0,%d1)
| Border Done 
	subq.w #2,%d6
	subq.w #2,%d7
.even
 StartNewIteration: | Iteration Loop 
	moveq.l #1, %d3 
	clr.w %d4
	clr.w %d5
 ContinueIteration:
	addq.w #1,%d3
	cmp.w #Iterations, %d3
	jbeq MakeRest

	jbsr rand
	move.b %d0  ,%d4
	muls.w %d6  ,%d4
	asr.w  #8   ,%d4
	addq.w #1   ,%d4
	and.w  #0xFE,%d4
	asr.w  #8   ,%d0
	move.b %d0  ,%d5
	muls.w %d7  ,%d5
	asr.w  #7   ,%d5 |Why does this work?
	addq.w #1   ,%d5
	and.w  #0xFE,%d5

	movea.l #0x4C00,%a0
	move.w %d4,%d0
	move.w %d5,%d1
	jbsr GetP
	tst.w %d0
	jbne ContinueIteration
	move.w %d4,%d0
	move.w %d5,%d1
	jbsr RunningLine
	jbra StartNewIteration
 MakeRest:
	addq.w #1,%d6
	addq.w #1,%d7
	movea.l #0x4C00,%a0
	clr.w %d4
 RestXl:
	addq.w #2,%d4
	cmp.w %d4,%d6
	jblt MakeDone
	clr.w %d5
 RestYl:
	addq.w #2,%d5
	cmp.w %d5,%d7
	jblt RestXl
	move.w %d4,%d0
	move.w %d5,%d1
	jbsr GetP
	tst.w %d0
	jbne RestYl
	move.w %d4,%d0
	move.w %d5,%d1
	jbsr RunningLine
	jbra RestYl
 MakeDone:
	move.l (0x26A*4,%a5), %a0 |memcpy
	jbsr (%a0)
	lea (12,%sp),%sp
	movem.l (%sp)+, %d3-%d7/%a2
	rts
	.even
solve:
	movem.l %d3-%d7/%a2-%a3,-(%sp) |d3,d6,d7 saved for Twist temp
	pea 0xF00.w
	pea 0x4C00.w
	move.l %a0, -(%sp)
	pea 0xF00.w
	move.l %a0, -(%sp)
	pea 0x4C00.w
|stack is ready for LCD_restore and LCD_save

	move.l (0x26A*4,%a5), %a3 |memcpy
	jbsr (%a3)
	lea (12,%sp),%sp

| a0=LCD_MEM, a2=&GetP
	movea.l #0x4C00, %a0
	lea GetP,%a2
	moveq.l #0,%d5
 SolveLoopY: |while (++d5 < set_H)
	addq.b #1,%d5
	cmp.b set_H,%d5
	jbeq SolveDone
	moveq.l #0,%d4
 SolveLoopX: |while (++d4 < set_W)
	addq.b #1,%d4
	cmp.b set_W,%d4
	jbeq SolveLoopY
|||||||||||||||||||||||||||||||||||||||
	move.w %d4,%d0
	move.w %d5,%d1
	jbsr (%a2)
	tst.w %d0
	jbne SolveLoopX

	movem.w %d4-%d5, -(%sp)
	move.w %d4,%d6 |newX
	move.w %d5,%d7 |newY
 TwistLoop:
	cmp.w #1, %d5
	jbne Tw1
	cmp.w #1, %d4
	jbeq ExitTwist |at the start
 Tw1: |(x-1,y)
	clr.b %d3
 	move.w %d4,%d0
	move.w %d5,%d1
	subq.b #1,%d0
	jbsr (%a2)
	tst.w %d0
	jbne Tw2
	moveq.l #1,%d3
	subq.b #1,%d6
 Tw2: |(x,y-1)
	move.w %d4,%d0
	move.w %d5,%d1
	subq.b #1,%d1
	jbsr (%a2)
	tst.w %d0
	jbne Tw3
	tst.b %d3
	jbne ExitTwist
	moveq.l #1,%d3
	subq.b #1,%d7
 Tw3: |(x+1,y) 
	move.w %d4,%d0
	move.w %d5,%d1
	addq.b #1,%d0
	jbsr (%a2)
	tst.w %d0
	jbne Tw4
	tst.b %d3
	jbne ExitTwist
	moveq.l #1,%d3
	addq.b #1,%d6
 Tw4: |(x,y+1)
	move.w %d4,%d0
	move.w %d5,%d1
	addq.b #1,%d1
	jbsr (%a2)
	tst.w %d0
	jbne DrawMove
	tst.b %d3
	jbne ExitTwist
	moveq.l #1,%d3
	addq.b #1,%d7
 DrawMove:
	move.w %d4,%d0 |current -> draw
	move.w %d5,%d1
	move.w %d6,%d4 |new -> current
	move.w %d7,%d5
	jbsr DrawScrnP
	tst.b %d3
	jbne TwistLoop |otherwize deadend 
 ExitTwist:	
	movem.w (%sp)+, %d4-%d5
	jbra SolveLoopX
|||||||||||||||||||||||||||||||||||
 SolveDone:
	jbsr (%a3) |memcpy, previously prepared
	lea (12,%sp),%sp
	movem.l (%sp)+, %d3-%d7/%a2-%a3
	jbra WaitForEnter
	.even
play:
	movem.l %d3-%d7/%a2-%a3,-(%sp)
	move.l %a0,%a3
	move.l (%a5,0x19E*4),%a0 |clrscr
	jbsr (%a0)
	moveq.l #1,%d3
	moveq.l #1,%d4
 PlayLoopSetD7:
 	move.w #nokey_delay,%d7
 PlayLoop:
	tst.w %d3
	jblt OutofPlay
	cmp.b set_W, %d3
	jbcc OutofPlay |jbgt will NOT work here
	tst.w %d4
	jblt OutofPlay
	cmp.b set_H, %d4
	jbcc OutofPlay
	moveq.l #-1,%d5
 PlayDrawX:
	addq.w #1,%d5
	cmp.w #30,%d5
	jbeq PlayDrawZ
	moveq.l #-1,%d6
 PlayDrawY:
	addq.w #1,%d6
	cmp.w #16,%d6
	jbeq PlayDrawX
	move.w %d5,%d0
	add.w %d3,%d0
	sub.w #YourX,%d0
|d0 is X coordinate of maze
	tst.w %d0
	jblt WhiteSprite
	cmp.b set_W, %d0
	jbgt WhiteSprite
	move.w %d6,%d1
	add.w %d4,%d1
	sub.w #YourY,%d1
|d1 is Y coordinate of maze
	tst.w %d1
	jblt WhiteSprite
	cmp.b set_H,%d1
	jbgt WhiteSprite

	move.l %a3,%a0
	jbsr GetP
	tst.w %d0
	jbeq WhiteSprite
	moveq.l #0,%d2
	jbra DoSprite
 WhiteSprite:
	moveq.l #1,%d2
 DoSprite:
	move.w %d5,%d0
	move.w %d6,%d1
	jbsr DrawSprite
	jbra PlayDrawY
 PlayDrawZ: |delay loop
	move.l (%a5,0x29B*4),%a2 |idle
 PDelayLoop:
	jbsr (%a2)
	subq.w #1, %d7
	jbne PDelayLoop

	lea rowread,%a2
	move.w #esc_1,%d0
	jbsr (%a2)
	and.b #esc_2,%d0
	jbne ExitPlay
	move.l #apps_1,%d0
	jbsr (%a2)
	and.b #apps_2,%d0
	jbeq GetDir
	move.l %a3,%a0
	jbsr disp
	jbra PlayLoopSetD7
 GetDir:
	moveq.l #1,%d0
	jbsr (%a2)

	move.w %d0,%d5
	lsr.w #k_R,%d5
	and.w #1,%d5
	move.w %d0,%d2
	lsr.w #k_L,%d2
	and.w #1,%d2
	sub.w %d2,%d5

	move.w %d0,%d6
	lsr.w #k_D,%d6
	and.w #1,%d6
	move.w %d0,%d2
.if ver_89

.else
	lsr.w #k_U,%d2
.endif
	and.w #1,%d2
	sub.w %d2,%d6

	move.w %d0,%d7
	and.w #K_shift,%d0
	jbeq NoCheat
	add.w %d5,%d5
	add.w %d6,%d6
 NoCheat:
	cmp.w %d5,%d6
	jbeq PlayLoopSetD7

	lea GetP,%a2
 MoveLoop:
	move.l %a3,%a0 |Maze in a0
	move.w %d3,%d0
	move.w %d4,%d1
	add.w %d5,%d0
	add.w %d6,%d1
	jbsr (%a2) |Test destination
	tst.w %d0
	jbne PlayLoopSetD7
	add.w %d5,%d3
	add.w %d6,%d4 
	move.w #esc_1,%d0
	jbsr rowread
	and.b #esc_2,%d0
	jbne ExitPlay

	move.w %d6,-(%sp) |push d6, which is now counter
	moveq.l #0,%d6
	move.w %d3,%d0
	move.w %d4,%d1
	subq.w #1,%d0
	jbsr (%a2) |if (x-1,y) then d6==1
	tst.w %d0
	jbne Pt2
	moveq.l #1,%d6
 Pt2:
	move.w %d3,%d0
	move.w %d4,%d1
	addq.w #1,%d0
	jbsr (%a2)
	tst.w %d0
	jbne Pt3 |if (x+1,y) then d6+=1 [is now 1 or 2]
	addq.w #1,%d6
 Pt3:
	move.w %d3,%d0
	move.w %d4,%d1
	subq.w #1,%d1
	jbsr (%a2)
	tst.w %d0
	jbne Pt4 |if (x,y-1) then if d6==2, intersect (third path) 
	cmp.w #2,%d6 
	jbeq Intersection
	tst.w %d6 |if d6 is still 0, this cannot be intersection
	jbeq NotIntersection
	moveq.l #2,%d6 |otherwise, d6 was 1 and is now 2
 Pt4:
	move.w %d3,%d0
	move.w %d4,%d1
	addq.w #1,%d1
	jbsr (%a2)
	tst.w %d0 |if (x,y+1) and (d6==2) then intersection
	jbne NotIntersection
	cmp.w #2,%d6
	jbeq Intersection
 NotIntersection:
	move.w (%sp)+,%d6
	btst #k_second,%d7
	jbne MoveLoop
	btst #k_diamond,%d7
	jbne MoveLoop
	move.w #play_delay, %d7
	jbra PlayLoop
 Intersection:
	move.w (%sp)+,%d6
	btst #k_diamond,%d7
	jbne MoveLoop
	move.w #intersection_delay,%d7
	jbra PlayLoop
 OutofPlay:
	move.l (%a5,0x19E*4),%a0 |clrscr
	jbsr (%a0)
	move.w #2,-(%sp)
	move.l (0x18F*4,%a5),%a0 |Large Font
	jbsr (%a0)
	move.w #4,-(%sp) |A_REPLACE
	and.b #0xFE,%d3
	cmp.b set_W, %d3
	jbne Cheater
	addq.b #1, %d4
	cmp.b set_H, %d4
	jbne Cheater
	pea TXT_Win
	jbra ShowTxt
 Cheater:
	pea TXT_Cheat
 ShowTxt:
	move.w #YouWinY, -(%sp)
	move.w #YouWinX, -(%sp)
	move.l (0x1A9*4,%a5),%a0 |DrawStr
	jbsr (%a0)
	lea (12,%sp),%sp |4 words, 1 pea
 ExitPlay:
	movem.l (%sp)+,%d3-%d7/%a2-%a3
	jbra WaitForEnter
||||||||||||||||||||||||||||||||||||||||||||
 TXT_Win:
	.asciz "You won!"
 TXT_Cheat:
	.asciz "Cheater!"
	.even
disp:
	pea 0xF00.w
	move.l %a0,-(%sp)
	pea 0x4C00.w
	move.l (0x26A*4,%a5),%a0 |memcpy
	jbsr (%a0)
	lea (12,%sp),%sp
.even
WaitForEnter:
	lea rowread,%a0
 PressLoop:
	move.w #enter_1,%d0
	jbsr (%a0)
	and.b #enter_2,%d0
	jbne ReleaseLoop
	move.w #esc_1,%d0
	jbsr (%a0)
	and.b #esc_2,%d0
	jbeq PressLoop
 ReleaseLoop:
	move.w #enter_1,%d0
	jbsr (%a0)
	and.b #enter_2,%d0
	jbne ReleaseLoop
	move.w #esc_1,%d0
	jbsr (%a0)
	and.b #esc_2,%d0
	jbne ReleaseLoop
	rts
	.even
RunningLine:
	movem.w %d3-%d7, -(%sp)
	move.w %d0,%d3
	move.w %d1,%d4
	clr.w %d5
	clr.w %d6
	move.b set_T,%d5
	move.b set_P,%d6
	jbsr rand
	move.w %d0,%d7
	and.w #3,%d7
 RunLoop:
	move.w #0x4C00,%a0
	move.w %d3,%d0
	move.w %d4,%d1
	jbsr GetP
	jbne DrawDone
	move.w %d3,%d0
	move.w %d4,%d1
	jbsr DrawScrnP

	subq.w #1,%d5 |Threshold--
	tst.w %d5
	jbgt RunStep
	btst.b #0,%d5
	jbeq RunStep
	jbsr rand
	mulu.w %d6,%d0 | if ((rand*Prob)/(2^15) == 0) ret
	moveq.l #15,%d1
	asr.l %d1,%d0
	tst.w %d0
	jbeq DrawDone
 RunStep:	
	tst.b %d7
	jbeq Dir4
	cmp.b #1,%d7
	jbeq Dir3
	cmp.b #2,%d7
	jbeq Dir2
 Dir1:
	addq.b #1,%d3
	jbra RunLoop
 Dir2:
	addq.b #1,%d4
	jbra RunLoop
 Dir3:
	subq.b #1,%d3
	jbra RunLoop
 Dir4:
	subq.b #1,%d4
	jbra RunLoop
 DrawDone:
	movem.w (%sp)+, %d3-%d7
	rts
	.even
DrawSprite:
	move.w %d1, -(%sp) |push y
	muls.w #0xF0, %d1  | (y*30*8) 
	add.w %d0,%d1
	add.w #0x4C00, %d1 | + x + 0x4C00 
	move.w %d1,%a0     | -> a0 
	move.w (%sp)+, %d1 |pop y

	cmp.w #YourX, %d0
	jbne SpriteNormal
	cmp.w #YourY, %d1
	jbeq SpriteCircle
 SpriteNormal:
	subq.b #1, %d2 |d2 is either 0 or 0xFF
	moveq.l #8,%d0
 S_N_loop:
	move.b %d2,(%a0)
	lea (30,%a0),%a0
	subq.w #1,%d0
	jbne S_N_loop
	rts
 SpriteCircle:
	lea Circle, %a1
	clr.w %d0
 S_P_loop:
	move.b (%a1,%d0.w),(%a0)
	lea (30,%a0),%a0
	addq.w #1,%d0
	cmp.w #7,%d0
	jble S_P_loop
	rts
.even
 Circle:
	dc.b 0x3C
	dc.b 0x42
	dc.b 0xA5
	dc.b 0x99
	dc.b 0x99
	dc.b 0xA5
	dc.b 0x42
	dc.b 0x3C
	.even
DrawStrR:
	move.w #4,-(%sp)
	move.l %a0,-(%sp)
	move.w %d0,-(%sp)
	move.w #DrawStrR_Xval, -(%sp)
	move.l (0x1A9*4,%a5),%a0
	jbsr (%a0)
	lea (10,%sp),%sp
	rts

	.even
DrawScrnP:
	jbsr GetIncr__
	move.w %d1,%a1
	or.b %d0,(0x4C00,%a1)
	rts

	.even
GetP:
	jbsr GetIncr__
	move.b (%a0,%d1),%d1
	and.w %d1,%d0
	rts

	.even
rowread:
	not.w %d0
	move.w %d0,0x600018
	moveq.l #30,%d0
 0:
	dbra %d0,0b
	move.b 0x60001B,%d0
	not.b %d0
	and.w #0xFF,%d0
	rts

	.even
 GetIncr__:
	move.w %d0,%d2
	muls.w #30,%d1
	lsr.w #3,%d0
	and.w #31,%d0
	add.w %d0,%d1 |d1 = y*30 + x/8

	not.w %d2
	and.w #7,%d2 |d2=~x%8
	moveq.l #1,%d0
	lsl.w %d2,%d0 |d0 = 1<<d2
	rts
	.even

DispMenu:
	movem.l %d3/%a2, -(%sp)
	move.l (%a5,0x19E*4),%a0 |clrscr
	jbsr (%a0)	
	move.w #2,-(%sp)
	move.l (0x18F*4,%a5),%a2 | FontSetSys 
	jbsr (%a2)
	lea TXT_Maze, %a0
	moveq.l #TitleRow, %d0
	jbsr DrawStrR
	move.w #1,-(%sp)
	jbsr (%a2)
	addq.l #4,%sp

	moveq.l #(Menu_ItemHeight*2), %d3
	lea MenuText,%a2
 TextLoop:
	move.w %d3,%d0
	move.l %a2,%a0
	jbsr DrawStrR
	add.w #Menu_ItemHeight, %d3
	lea (12,%a2),%a2
	cmp.w #(Menu_ItemHeight*10),%d3
	jble TextLoop
	movem.l (%sp)+, %d3/%a2
	rts
	.even
P_TXT_Maze:
	.long TXT_Maze
MenuText:
	|      0123456789012 
	.asciz "1 - Make   "
	.asciz "2 - Solve  "
	.asciz "3 - Play   "
	.asciz "4 - Save   "
	.asciz "5 - Load   "
	.asciz "6 - View   "
	.asciz "7 - Options"
	.asciz "8 - Exit"
TXT_Maze: |starts with zero (from previous string) and ends with 0x0,0xF8
	.asciz "Maze"
	dc.b 0xF8 |OTH_TAG
